--*** Wireframe cube using m19lib. ***--

include m19lib.e

sequence points,points2,faces
integer v
atom vscreen
atom time1,time2,frames

vscreen=allocate(64000)

points2={
 {-1,-1,-1},
 {1,-1,-1},
 {1,1,-1},
 {-1,1,-1},
 {-1,-1,1},
 {1,-1,1},
 {1,1,1},
 {-1,1,1}
}
points2=points2*50

set_vga()
make_trigTb()

v=1
frames=0
time1=time()
while get_key()=-1 do
 mem_cls(vscreen,0)
 points=rotate(points2,{1,1,1},{v,v,v})
 faces={
  points[1..4],
  points[5..8]
 }
 faces=get_screen_xy({160,100},faces)
 for i=1 to 3 do
  asm_line({faces[1][i],faces[1][i+1]},9,vscreen)
  asm_line({faces[2][i],faces[2][i+1]},9,vscreen)
 end for
 asm_line({faces[1][4],faces[1][1]},9,vscreen)
 asm_line({faces[2][4],faces[2][1]},9,vscreen)
 asm_line({faces[1][1],faces[2][1]},9,vscreen)
 asm_line({faces[1][2],faces[2][2]},9,vscreen)
 asm_line({faces[1][3],faces[2][3]},9,vscreen)
 asm_line({faces[1][4],faces[2][4]},9,vscreen)
 wait_vrt()
 asm_copy_screen(vscreen,#A0000)
 frames=frames+1
 v=v+2
 if v>=361 then
  v=1
 end if
end while
time2=time()

restore_graphics()
free_asm_code()
free(vscreen)

printf(1,"%d frames per second.\n",floor(frames/(time2-time1)))
